/*
  Copyright 2006 by Sean Luke
  Licensed under the Academic Free License version 3.0
  See the file "LICENSE" for more information
*/


/*
 * Created on Apr 16, 2005 12:36:14 PM
 * 
 * By: spaus
 */
package uah.regex.stats;

import ec.display.chart.*;
import ec.EvolutionState;
import ec.util.Parameter;
import ec.vector.*;

/**
 * @author spaus
 */
@SuppressWarnings("serial")
public class SimpleSizeChartStatistics
    extends XYSeriesChartStatistics {

    private int[] seriesID;
    
    public void setup(EvolutionState state, Parameter base) {
        super.setup(state, base);
        int numSubPops = state.parameters.getInt(new Parameter("pop.subpops"),null);
        seriesID = new int[numSubPops];
        
        for (int i = 0; i < numSubPops; ++i) {
            seriesID[i] = addSeries("SubPop "+i);
            }
    }
    
    public void postEvaluationStatistics(EvolutionState state) {
        super.postEvaluationStatistics(state);
        
        for (int subPop = 0; subPop < state.population.subpops.length; ++subPop) {
        	long lengthPerGen = 0;
        	
            for(int y=0;y<state.population.subpops[subPop].individuals.length;y++)
            	lengthPerGen += ((BitVectorIndividual) state.population.subpops[subPop].individuals[y]).genomeLength();

            addDataPoint(seriesID[subPop], state.generation, lengthPerGen / state.population.subpops[subPop].individuals.length);
            }
    }
    }
